
#ifndef DISA8255LAB_H
#define DISA8255LAB_H

#include <linux/ioctl.h> 

#define disa8255lab_major 157
#define MAXCARD 2
#define REGIONLENGTH 16

#define DISA8255LAB_WRITE_PORT           _IOW(disa8255lab_major, 0 , char)
#define DISA8255LAB_READ_PORT            _IOR(disa8255lab_major, 1 , char)
#define DISA8255LAB_WRITE_COUNTER        _IOW(disa8255lab_major, 2 , int)
#define DISA8255LAB_READ_COUNTER         _IOR(disa8255lab_major, 3 , int)
#define DISA8255LAB_SET_REGISTER         _IOW(disa8255lab_major, 4 , int)
#define DISA8255LAB_SET_CONTROLWORD      _IOW(disa8255lab_major, 5 , char)
#define DISA8255LAB_GET_CONTROLWORD      _IOR(disa8255lab_major, 6 , char)
#define DEVICE_NAME "disa8255lab"

/* first 8255 on the card */
#define PORTA1 0
#define PORTB1 1
#define PORTC1 2
#define CONTROLWORD1 10

/*   second 8255 on the card */
#define PORTA2 3
#define PORTB2 4
#define PORTC2 5
#define CONTROLWORD2 11

/* 8253 on the card */
#define COUNTER1 6
#define COUNTER2 7
#define COUNTER3 8
#define CONTROLWORD3 12

int WritePort(int file_desc,int port,char value);
char ReadPort(int file_desc,int port);

int SetControlWord(int file_desc,int port,char value);
char GetControlWord(int file_desc,int port);

int WriteCounter(int file_desc,int number,int value);
int ReadCounter(int file_desc,int number);
#endif


  

