#include "disa8255lab.h"  
#include <sys/ioctl.h>  /* ioctl */


int WriteCounter(int file_desc, int number,int value)
{
  int ret_val;
  if((number<COUNTER1)||(number>COUNTER3)) return -1;
  ret_val = ioctl(file_desc, DISA8255LAB_SET_REGISTER, number);
  ret_val = ioctl(file_desc, DISA8255LAB_WRITE_COUNTER, value);
  return ret_val;
}

int ReadCounter(int file_desc, int number)
{
  int ret_val=0;
  if((number<COUNTER1)||(number>COUNTER3)) return -1;
  ioctl(file_desc, DISA8255LAB_SET_REGISTER, number);
  ioctl(file_desc, DISA8255LAB_READ_COUNTER, &ret_val);
  return ret_val;
}

int WritePort(int file_desc, int port,char value)
{
  int ret_val;
  if((port<0)||(port>PORTC2)) return -1;
  ret_val = ioctl(file_desc, DISA8255LAB_SET_REGISTER, port);
  ret_val = ioctl(file_desc, DISA8255LAB_WRITE_PORT, value);
  return ret_val;
}

char ReadPort(int file_desc, int port)
{
  char ret_val;
  if((port<0)||(port>PORTC2)) return -1;
  ioctl(file_desc, DISA8255LAB_SET_REGISTER, port);
  ioctl(file_desc, DISA8255LAB_READ_PORT, &ret_val);
  return ret_val;
}

int SetControlWord(int file_desc, int port, char value)
{
 int ret_val;
  ret_val = ioctl(file_desc, DISA8255LAB_SET_REGISTER, port);
  ret_val = ioctl(file_desc, DISA8255LAB_SET_CONTROLWORD, value);
  return ret_val;
}

char GetControlWord(int file_desc, int port)
{
  char ret_val;
  if((port<0)||(port>PORTC2)) return -1;
  ioctl(file_desc, DISA8255LAB_SET_REGISTER, port);
  ioctl(file_desc, DISA8255LAB_GET_CONTROLWORD, &ret_val);
  return ret_val;
}